/* Asteroids class
 *
 * CMSC498B
 * Project 4
 * April 25, 2002
 *
 * Chad Ellinger
 * Developed with JDK 1.3.1_02 in Windows XP
 */

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;

/**
 * An <code>Asteroid</code> object creates a <code>Glyph</code> object of equal
 * width and height with a specified image.
 */
public class Asteroid extends Glyph{
    Image asteroidImage = null;
    GameWindow iObserver = null;

    /**
     * Constructs a new Asteroid with the given dimensions, image file and
     * image observer.
     */
    public Asteroid(int width, int height, Image img, GameWindow iObserver){
	this.width = Math.max(width, height);
	this.height = Math.max(width, height);
	asteroidImage = img;
	this.iObserver = iObserver;
	glyphShape = new Ellipse2D.Double(0, 0, this.width, this.height);
    }

    /**
     * Sets the image for this Asteroid.
     *
     * @param img The new Image for this Asteroid.
     */
    public void setImage(Image img){
	asteroidImage = img;
	return;
    }

    /**
     * Sets the image observer for this Asteroid.
     *
     * @param iObserver The new ImageObserver for this Asteroid.
     */
    public void setImageObserver(GameWindow iObserver){
	this.iObserver = iObserver;
	return;
    }
   
    /**
     * Overriden to draw Asteroid image at current width and height.
     */
    protected void drawGlyph(Graphics2D g2){
	g2.drawImage(asteroidImage, 0, 0, this.width, this.height, iObserver);
	if (selected){
	    g2.setColor(Color.cyan);
	    g2.draw(glyphShape);
	}
    }
}
