/* Ship class
 *
 * CMSC498B
 * Project 4
 * April 25, 2002
 *
 * Chad Ellinger
 * Developed with JDK 1.3.1_02 in Windows XP
 */

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;

/**
 * A <code>Ship</code> object creates a <code>Glyph</code> with a polygonal shape and default acceleration
 * rate. The ship's angle and direction are always the same.
 */
public class Ship extends Glyph{
    private Color wingColor = Color.red;

    public Ship(){
	linearSpeed = 0;
	direction = Math.PI / -2;
	angle = Math.PI / -2;
	maxSpeed = 60;
	accelRate = 40;
	width = 40;
	height = 30;
	int[] xShipPoints = {this.width, (int)(this.width*0.58), 0, (int)(this.width*.33), (int)(this.width*.25),
			     (int)(this.width*.25), (int)(this.width*.33), 0,
			     (int)(this.width*0.58), this.width};
	int[] yShipPoints = {this.height / 2, this.height / 3, 0, this.height / 3, (int)(this.height*0.42),
			     (int)(this.height*0.58), (int)(this.height*0.67), this.height,
			     (int)(this.height*0.67), this.height / 2};
	glyphShape = new Polygon(xShipPoints, yShipPoints, 10);
    }

    /**
     * Overriden. Sets both the direction and angle to the specified direction.
     */
    public void setDirection(double direction){
	this.direction = direction;
	this.angle = direction;
	return;
    }

    /**
     * Overriden. Sets both the direction and angle to the specified angle.
     */
    public void setAngle(double angle){
	this.angle = angle;
	this.direction = angle;
	return;
    }

    /**
     * Sets the wings of the ship to the specified color.
     */
    public void setWingColor(Color newColor){
	wingColor = newColor;
	return;
    }

    /**
     * Overriden. Draws the polygonal shapes that form the ship.
     */
    protected void drawGlyph(Graphics2D g2){
	g2.setColor(glyphColor);
	g2.fill(glyphShape);
	int[] xWingPoints = {this.width / 2, (int)(this.width*0.17), (int)(this.width*0.42)};
	int[] yWingPoints = {this.height / 3, (int)(this.height*0.15), this.height / 3};
	g2.setColor(wingColor);
	g2.fillPolygon(xWingPoints, yWingPoints, 3);
	yWingPoints[0] = (int)(this.height*0.67);
	yWingPoints[1] = (int)(this.height*0.85);
	yWingPoints[2] = (int)(this.height*0.67);
	g2.fillPolygon(xWingPoints, yWingPoints, 3);
	int[] xWindowPoints = {(int)(this.width*.75), (int)(this.width*0.58), (int)(this.width*0.58),
			       (int)(this.width*.75)};
	int[] yWindowPoints = {(int)(this.height*0.45), (int)(this.height*0.4), (int)(this.height*0.6),
			       (int)(this.height*0.55)};
	g2.setColor(Color.gray);
	g2.fillPolygon(xWindowPoints, yWindowPoints, 4);
	g2.fillRect((int)(this.width*0.15), (int)(this.height*0.42), (int)(this.width*0.1), (int)(this.height*0.2));
	if (accel){
	    g2.setColor(Color.orange);
	    int[] xFlamePoints = {(int)(this.width*0.15), 0, (int)(this.width*0.15)};
	    int[] yFlamePoints = {(int)(this.height*0.42), this.height / 2, (int)(this.height*0.58)};
	    g2.fillPolygon(xFlamePoints, yFlamePoints, 3);
	}
	if (selected){
	    g2.setColor(Color.cyan);
	    g2.draw(glyphShape);
	}
    }
}
